/*
 * leds.xc
 *
 *  Created on: Dec 13, 2012
 *      Author: ah6
 */

#include <platform.h>
#include "leds.h"

out port A = on tile[0]:XS1_PORT_4A;
out port B = on tile[0]:XS1_PORT_4B;
out port C = on tile[0]:XS1_PORT_4C;
out port led_green = on tile[0]:XS1_PORT_1E;
out port led_red   = on tile[0]:XS1_PORT_1F;

#define OFF 0
#define ON  1

void LedManager(chanend cmd) {
    int value;
    const int lookup[] = {
          0b1111, 0b1111, 0b1111, // -12
          0b1111, 0b1111, 0b1110, // -11
          0b1111, 0b1111, 0b1100, // -10
          0b1111, 0b1111, 0b1000, // -9
          0b1111, 0b1111, 0b0000, // -8
          0b1110, 0b1111, 0b0000, // -7
          0b1100, 0b1111, 0b0000, // -6
          0b1000, 0b1111, 0b0000, // -5
          0b0000, 0b1111, 0b0000, // -4
          0b0000, 0b1110, 0b0000, // -3
          0b0000, 0b1100, 0b0000, // -2
          0b0000, 0b1000, 0b0000, // -1
          0,           0, 0b0001, // 0
          0,           0, 0b0011, // 1
          0,           0, 0b0111, // 2
          0,           0, 0b1111, // 3
          0b0001,      0, 0b1111, // 4
          0b0011,      0, 0b1111, // 5
          0b0111,      0, 0b1111, // 6
          0b1111,      0, 0b1111, // 7
          0b1111, 0b0001, 0b1111, // 8
          0b1111, 0b0011, 0b1111, // 9
          0b1111, 0b0111, 0b1111, // 10
          0b1111, 0b1111, 0b1111, // 11
    };
    while(1) {
        cmd :> value;
        if (value < 0) {
            led_green <: OFF;
            led_red   <: ON;
        } else {
            led_green <: ON;
            led_red   <: OFF;
        }
        value += 12;
        if (value < 0) value = 0;
        if (value > 23) value = 23;
        A <: lookup[value*3];
        B <: lookup[value*3 + 1];
        C <: lookup[value*3 + 2];
    }
}
