/*
 * mpu6050.h
 *
 *  Created on: Nov 28, 2012
 *      Author: ah6
 */

#ifndef MPU6050_H_
#define MPU6050_H_

#include "i2c.h"
#include "mpu6050regs.h"

#define GYRO_SENSITIVITY 65.536


struct IMU {
    struct r_i2c i2c;
    int gyro_x_offset ;
    int gyro_y_offset ;
    int gyro_z_offset ;
};

void delay_ms(const int delay);

void imu_setup(REFERENCE_PARAM(struct IMU, imu));

unsigned char mpu_read_byte(REFERENCE_PARAM(struct r_i2c, mpu), const int reg);

short mpu_read_short(REFERENCE_PARAM(struct r_i2c, mpu), const int reg);

{int, int, int} get_gyro_raw(REFERENCE_PARAM(struct IMU, imu));

{float, float, float} get_gyro(REFERENCE_PARAM(struct IMU, imu));

void calibrate_gyros(REFERENCE_PARAM(struct IMU, imu));

{int, int, int} get_accel_raw(REFERENCE_PARAM(struct IMU, imu));

{float, float} get_accel_angles(REFERENCE_PARAM(struct IMU, imu));

{float, float} norm_accel(int raw_x, int raw_y, int raw_z);

float estimate_angle(float gz, float ax, int elapsed);

#endif /* MPU6050_H_ */
